freeslot("MT_ROGERCHAIR", "S_ROGERCHAIR_IDLE", "S_ROGERCHAIR_TRIG", "SPR_CHRS", "SPR_MASH", "S_MASHBUTTONS")
states[S_ROGERCHAIR_IDLE] = {SPR_CHRS, A, -1, nil, 0, 0, S_NULL}
states[S_ROGERCHAIR_TRIG] = {SPR_CHRS, B, -1, nil, 0, 0, S_NULL}
states[S_MASHBUTTONS] = {SPR_MASH, A|FF_FULLBRIGHT, 5, nil, 0, 0, S_NULL}
mobjinfo[MT_ROGERCHAIR] = {
	doomednum = 1579,
	spawnstate = S_ROGERCHAIR_IDLE,
	spawnhealth = 1,
	speed = FRACUNIT,
	radius = 16*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 0,
	reactiontime = 0,
	mass = 100,
	damage = 0,
	flags = MF_SCENERY|MF_SPECIAL
}
local function StopSpin(mobj)
	if mobj.speen
		mobj.speen = false
		mobj.spriteyoffset = 0
		P_InstaThrust(mobj, mobj.startspeen, -5*FRACUNIT)
		P_SetObjectMomZ(mobj, 5*FRACUNIT)
		mobj.state = S_ROGERCHAIR_IDLE
		mobj.nosoft = TICRATE*3
		if mobj.tracer and mobj.tracer.valid
			if mobj.tracer.player
				mobj.tracer.momx = mobj.momx/3*2
				mobj.tracer.momy = mobj.momy/3*2
				mobj.tracer.momz = mobj.momz/2*3
				mobj.tracer.state = S_PLAY_PAIN
				mobj.tracer.spritexoffset = 0
				mobj.tracer.spriteyoffset = 0
				mobj.tracer = nil
			end
		end
	end
end
addHook("TouchSpecial", function(mobj, mo)
	if mobj and mobj.valid
		if mo and mo.valid 
		and not mobj.speen
		and not mobj.nosoft
			if (mo.state != S_PLAY_PAIN)
			and mo.player and not (mo.momz*P_MobjFlip(mo) > mo.scale)
			and not (mobj.tracer and mobj.tracer != mo)
				if not S_SoundPlaying(mobj, sfx_cdfm37)
					S_StartSound(mobj, sfx_cdfm37)
				end
				mobj.state = S_ROGERCHAIR_TRIG
				mobj.speen = true
				mobj.tracer = mo
				mobj.startspeen = R_PointToAngle2(0, 0, mo.momx, mo.momy)
				mobj.angle = mobj.startspeen
				mo.state = S_PLAY_PAIN
				mo.player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
				mobj.speeding =  mo.player.speed + ((mobj.startspeedangle/ANG1*FRACUNIT)*2)
				mobj.friction = FRACUNIT
				P_InstaThrust(mobj, mobj.startspeen, mobj.speeding)
				local mox = mobj.momx
				local moy = mobj.momy
				if mox < 0 mox = $*-1 end
				if moy < 0 moy = $*-1 end
				mobj.startspeed = moy+mox
			end
		end
		return true
	end
end, MT_ROGERCHAIR)

--PLEASE don't apply a MobjThinker to every single object type in existence, that is a recipe for lag.
--Anyway, I put the entire thinker on the chair, and manipulate the player through the chair thinker too for optimization.
local function ChairThinker(mo)
	if mo.valid
		mo.nosoft = $ or 0
		if mo.nosoft
			mo.nosoft = $ - 1
		end
		if mo.speen
			mo.angle = $ - ANG30
			mo.friction = FRACUNIT
			local mox = mo.momx
			local moy = mo.momy
			if mox < 0 mox = $*-1 end
			if moy < 0 moy = $*-1 end
			local momfinal = mox+moy		
			if (momfinal < ((mo.startspeed*2)/3)) --I'm making a new value called startspeed
			or (mo.momx == 0 and mo.momy == 0) --Complete standstill? Stop, duh.
				S_StartSound(mo, sfx_pstop)
				if mo.tracer and mo.tracer.valid
				and mo.tracer.player
					if mo.tracer.player.powers[pw_flashing] < 50
					mo.tracer.player.powers[pw_flashing] = 50
					end
					if (mo.tracer.player == displayplayer)
					P_StartQuake(60*FRACUNIT, 6)
					end
				end
				StopSpin(mo)
			end
			if mo.tracer and mo.tracer.valid
			and mo.tracer.player
			
			local s = mo.tracer --Shortcut for ease of use.
			local p = mo.tracer.player --p is easier for me than "player".
			
				P_RadiusAttack(s,s, p.speed+(70*s.scale)) --Add a little attack radius.			
				p.drawangle = mo.angle
				mo.nosoft = $ or 0
				if s.nosoft
					s.nosoft = $-1
				end
				//s.state = S_PLAY_PAIN
				
			--mo.chairspeed is simply mo now. This whole section is the old MT_PLAYER part.
				
				--Stay slightly in front of the chair at all times, otherwise it looks like it clips through you.
				P_TryMove(s, mo.x+mo.momx+FixedMul(20*s.scale, cos(mo.angle)), mo.y+mo.momy+FixedMul(20*s.scale, sin(mo.angle)), true) --TryMove is safer and won't get you teleported in walls.
				s.z = mo.z+(mo.height/2)+(mo.height/6)
				
				s.momx = mo.momx
				s.momy = mo.momy
				s.momz = mo.momz
				
					if p.timermash
						p.timermash = $ - 1
						if p.timermash >= 18
							p.mo.state = S_PLAY_JUMP
							if p.timermash >= 19
								s.spriteyoffset = P_RandomRange(-3, 3)*FRACUNIT
								s.spritexoffset = P_RandomRange(-3, 3)*FRACUNIT
							else	
								s.spriteyoffset = 0
								s.spritexoffset = 0
							end	
							p.mashing = true
						else
							s.state = S_PLAY_PAIN
							if p.mashing
								p.mashing = false
								s.spriteyoffset = 0
								s.spritexoffset = 0
								s.state = S_PLAY_PAIN
							end
						end
						p.stopmash = true
					else
						s.state = S_PLAY_PAIN
						if p.stopmash
							p.stopmash = false
							p.mashout = 0
						end
					end	
					if (p.cmd.buttons & BT_JUMP)
						if not p.jmp
							if not p.mashout
								p.mashout = 1
							else
								p.mashout = $ + 1
							end
							if (p == displayplayer)
								P_StartQuake(20*FRACUNIT, 2)
							end
							s.state = S_PLAY_JUMP
							s.spriteyoffset = P_RandomRange(-3, 3)*FRACUNIT
							s.spritexoffset = P_RandomRange(-3, 3)*FRACUNIT
							p.timermash = 13
							S_StartSound(s, sfx_cdfm48)
							if P_IsObjectOnGround(mo)
								P_SetObjectMomZ(mo, 8*FRACUNIT)
								S_StartSound(s, sfx_kc52)
								local ghs = P_SpawnGhostMobj(mo)
								ghs.color = SKINCOLOR_YELLOW
								ghs.colorized = true ghs.fuse = 7 ghs.destscale = $*99 ghs.spritexscale = $/2
							end
							local mash = P_SpawnMobjFromMobj(s, 0, 0, s.height, MT_THOK)
							mash.tics = TICRATE
							mash.fuse = 5
							mash.renderflags = RF_FULLBRIGHT|RF_NOCOLORMAPS
							mash.state = S_MASHBUTTONS
							mash.scale = FRACUNIT*4
							//mash.sprite.pivot.y = -15
							mash.rollangle = $ + P_RandomRange(-135, 135)*ANG1
						end
						p.jmp = true
					else
						p.jmp = false
					end
					if p.mashout and p.mashout >= 5
						p.mashout = 0
						p.timermash = 0
						p.stopmash = false
						s.spriteyoffset = 0
						s.spritexoffset = 0
						P_DoJump(p)
						P_SetObjectMomZ(s, 9*FRACUNIT)
						if mo.speen
							mo.speen = false
							P_Thrust(mo, mo.startspeen, -FRACUNIT*5)
							P_SetObjectMomZ(mo, -FRACUNIT)
							P_Thrust(s, mo.startspeen, 5*FRACUNIT)
							mo.state = S_ROGERCHAIR_IDLE
							mo.nosoft = TICRATE*2
							mo.tracer = nil
							return
						end
					end
			end
		elseif mo.tracer --Remove excess data.
			if mo.tracer.valid
			mo.tracer.spriteyoffset = 0
			mo.tracer.spritexoffset = 0
			end
			mo.tracer = nil
		end
	end
end
addHook("MobjThinker", ChairThinker,  MT_ROGERCHAIR)

--Collide with springs
local function ChairCollider(s,v)
	if not (v and (v.flags & MF_SPRING)) --Boosters and springs are technically the same thing in SRB2.
	return
	end
	if s.valid
	and not (s.z > v.z+v.height) --Vertical height checks.
	and not (v.z > s.z+s.height)
		if v.info.damage --A spring's damage value is how far it'll propell you horizontally!
			P_InstaThrust(s, v.angle, v.info.damage)
		end
		if v.info.mass --A spring's mass value is how far it'll propell you vertically!
			P_SetObjectMomZ(s, v.info.damage*P_MobjFlip(v), false)
		end
		
		local mox = s.momx
		local moy = s.momy
		if mox < 0 mox = $*-1 end
		if moy < 0 moy = $*-1 end
		s.startspeed = moy+mox --Reset startspeed.
		
		if not S_OriginPlaying(v)
		and mobjinfo[v.type].painsound --Play the spring/booster sound.
		S_StartSound(v, mobjinfo[v.type].painsound)
		end
	end
end
addHook("MobjCollide", ChairCollider,  MT_ROGERCHAIR)
addHook("MobjMoveCollide", ChairCollider,  MT_ROGERCHAIR)

addHook("MobjSpawn", function(mo)
	if mo.valid
		mo.startspeedangle = mo.angle
		mo.shadowscale = 85356 --Give it a chunky shadow!
	end
end, MT_ROGERCHAIR)